const initialState = {
    company: null,
    currencyCompany: null
}

const state = {
    company: initialState.company,
    currencyCompany: initialState.currencyCompany
}

const getters = {
    /**
     * [company description]
     */
    company(state) {
        return state.company
    },
    /**
     * [currencyCompany description]
     */
    currencyCompany(state) {
        return state.currencyCompany
    }
}

const mutations = {
    /**
     * [company description]
     */
    setSelectedCompany(state, payload) {
        state.company = payload
    },
    /**
     * [currencyCompany description]
     */
    setSelectedCurrencyCompany (state, payload) {
        state.currencyCompany = payload
    }
}

const actions = {
    /**
     *[initPaymentsCompany]
     */
    initPaymentsCompany ({commit}, payload) {
        commit('setSelectedCompany',payload.company)
        commit('setSelectedCurrencyCompany', payload.currency)
    },
    /**
     *[RESET_COMPANY]
     */
    resetCompany ({ commit}) {
        commit('setSelectedCompany', [])
        commit('setSelectedCurrencyCompany', [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
