
const initialState ={
    journals: [],
    loadingJournal: false,
    selectedJournal: null,
    currencyJournal: []
}

const state = {
    journals: initialState.journals,
    loadingJournal: initialState.loadingJournal,
    selectedJournal: initialState.selectedJournal,
    currencyJournal: initialState.currencyJournal
}

const getters = {
    /**
     * [journals description]
     */
    journals(state) {
        return state.journals
    },
    /**
     * [loadingJournal description]
     */
    loadingJournal(state) {
        return state.loadingJournal
    },
    /**
     * [selectedJournal description]
     */
    selectedJournal (state) {
        return state.selectedJournal
    },
    /**
     * [currencyJournal description]
     */
    currencyJournal (state) {
        return state.currencyJournal
    }
}

const mutations = {
    /**
     * [SET_JOURNALS description]
     */
    setJournals (state, payload) {
        state.journals = payload
    },
    /**
     * [loadingJournal description]
     */
    setLoadingJournals (state, payload) {
        state.loadingJournal = !!payload
    },
    /**
     * [selectedJournal description]
     */
    setSelectedJournal (state, payload) {
        state.selectedJournal = payload
    },
    /**
     * [currencyJournal description]
     */
    setCurrencyJournal (state, payload) {
        state.currencyJournal = payload
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_JOURNALS]
     */
    initPaymentsJournals ({ commit },payload ) {
        commit('setJournals', payload)
        commit('setLoadingJournals', payload)
    },
    /**
     * [SELECT_JOURNAL]
     */
    selectJournal ({ commit, dispatch, getters },payload ) {
        let currency = []

        dispatch('resetPaymentsBank')
        commit('setSelectedJournal', payload)
        dispatch('calculateCurrencyTotal' , payload)

        if (payload.currency.id){
            currency = payload.currency
        } else {
            currency = getters.currencyCompany
        }

        commit('setCurrencyJournal', currency)
    },
    /**
     *  [RESET_SELECTED_JOURNAL]
     */
    resetSelectedJournal ({ commit, dispatch }){
        commit('setSelectedJournal', null)
        commit('setCurrencyJournal', [])
    },
    /**
     *  [RESET_JOURNALS]
     */
    resetJournals ({ commit }) {
        commit('setJournals', [] )
        commit('setSelectedJournal', null )
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
