const initialState = {
    user: null,
    loadingUser: false,
}

const state = {
    user: initialState.user,
    loadingUser: initialState.loadingUser,
}

const getters = {
    /**
     * [user]
     */
    user (state) {
        return state.user
    },
    /**
     * [loadingUser]
     */
    loadingUser (state) {
        return state.loadingUser
    }
}

const mutations = {
    /**
     * [actions description]
     */
    setUser (state, payload) {
        state.user = payload
    },
    /**
     * [actions description]
     */
    setLoadingUser (state, payload) {
        state.loadingUser = !!payload
    }
}

const actions ={
    /**
    * [INIT_PAYMENTS_USER]
     */
    initPaymentsUser({commit, dispatch}, payload) {
        commit('setUser', payload)
        commit('setLoadingUser', payload)

        dispatch('initPaymentsCompany', payload)
    },
    /**
     * [INIT_PAYMENTS_USER]
     */
    resetUser ({ commit }) {
        commit('setUser', [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
